/* acceptFlowData.cpp */

#include "acceptFlowData.h"

/* CONSTRUCTOR */
acceptFlowData::acceptFlowData(/*in*/ int id, /*in*/ int safid,
                               /*in*/ int afid, /*in*/ int amount)
{
  m_amount = amount;
  m_numResponses = 0;
  m_sourceId = id;
  m_sourceAFId = safid;
  m_acceptFlowId = afid;
}

/* MODIFICATION MEMBER FUNCTIONS for termData */
void acceptFlowData::modifyAmount(int amount)
{
  m_amount += amount;
}

acceptFlowData acceptFlowData::operator++()
{
  ++m_numResponses;
  return *this;
}

acceptFlowData acceptFlowData::operator++(int x)
{
  m_numResponses++;
  return *this;
}

acceptFlowData acceptFlowData::operator--()
{
  --m_numResponses;
  return *this;
}

acceptFlowData acceptFlowData::operator--(int x)
{
  m_numResponses--;
  return *this;
}

/* CONSTANT MEMBER FUNCTIONS for termData */
bool acceptFlowData::done() const
{
  return ((m_amount == 0) && (m_numResponses == 0));
}

int acceptFlowData::getAmount() const
{
  return m_amount;
}

int acceptFlowData::getAFId() const
{
  return m_acceptFlowId;
}

int acceptFlowData::getSourceId() const
{
  return m_sourceId;
}

int acceptFlowData::getSourceAFId() const
{
  return m_sourceAFId;
}
