#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <math.h>

void readData(char* fileName, int sourceId, int sinkId)
{
  FILE* f;
  char line[1024], dum[10];
  int i, j, flow, max, amount=0;

  /* attempt to open the file */
  if ((f=fopen(fileName, "r")) == 0)
    {
      fprintf(stderr, "File %s could not be opened", fileName);
      exit(EXIT_FAILURE);
    }

  while ( 0 != fgets( line, 1024, f))
    {
      switch (line[0])
	{
	case 'f':
	  sscanf(line, "%s%d%d%d%d", dum, &i, &j, &flow, &max);
	  if (i == sourceId)
	    {
	      amount += flow;
	    }
	  else if (j == sinkId)
	    {
	      amount -= flow;
	    }
	  break;
	}
    } /* end while */

  if (amount == 0)
    {
      printf("Max flow correct\n");
    }
  else
    printf("Max flow incorrect\n");

  fclose(f);
}

int main(int argc, char** argv)
{
  if (argc < 4)
    {
      fprintf(stderr, "Usage:  %s fileName.simple sourceId sinkId", argv[0]);
      exit(1);
    }

  readData(argv[1], atoi(argv[2]), atoi(argv[3]));

  printf("done\n");

  return 0;
}
