#include <strings.h>

#include "confVertex.h"

/* 
 *
 *  confVertex functions
 *
 */

confVertex::confVertex()
{
  m_port = 0;
  m_server = 0;
  m_source = m_sink = false;
}

confVertex::confVertex(const confVertex& s)
{
  /* NOTE:  The m_server would not have had data already assigned
   *           to it, which is why it doesn't need to be released.
   */

  m_server = new char[strlen(s.m_server)+1];
  strcpy(m_server, s.m_server);

  m_port = s.m_port;
  m_source = s.m_source;
  m_sink = s.m_sink;
}

confVertex::~confVertex()
{
  if (m_server)
    {
      delete [] m_server;
    }
}

const confVertex& confVertex::operator=(const confVertex& s)
{
  if (m_server)
    delete [] m_server;

  m_server = new char[strlen(s.m_server)+1];
  strcpy(m_server, s.m_server);

  m_port = s.m_port;
  m_source = s.m_source;
  m_sink = s.m_sink;

  return *this;
}

void confVertex::setPort(const int& fp)
{
  m_port = fp;
}

void confVertex::setServer(const char inServer[])
{
  m_server = new char[strlen(inServer)+1 ];
  strcpy(m_server, inServer);
}

void confVertex::setIsSource()
{
  m_source = true;
  return;
}

void confVertex::setIsSink()
{
  m_sink = true;
  return;
}

const char* confVertex::getServer() const
{
  return m_server;
}

int confVertex::getPort() const
{
  return m_port;
}

bool confVertex::isSource() const
{
  return m_source;
}

bool confVertex::isSink() const
{
  return m_sink;
}
