#ifndef _CONF_VERTEX_H_
#define _CONF_VERTEX_H_

class confVertex
{
public:
  confVertex();
  /* constructor
   * PRE:  id is the id of this vertex
   * POST: m_id = id
   *****************************************************************/

  confVertex(const confVertex& s);

  ~confVertex();

  /* MODIFICATION MEMBER FUNCTION for confVertex */
  void setPort(const int& fp);

  void setServer(const char inServer[]);
  /* 
   * PRE:  inServer must be a null terminated string
   *****************************************************************/

  void setIsSource();
  void setIsSink();

  const confVertex& operator=(const confVertex& s);

  /* CONSTANT MEMBER FUNCTIONS for confVertex */
  const char* getServer() const;
  int getPort() const;
  bool isSource() const;
  bool isSink() const;

private:
  int m_port;
  char* m_server;
  bool m_source, m_sink;
};

#endif
