#include <iostream.h>
#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <strings.h>
#include <stdlib.h>

#include "mfcontroller.h"

#define OPS_NUM 4

int look_up(char* s);

int main(int argc, char** argv)
{
  int fd, i;
  bool verbose = false;
  bool outFileDesired = false;
  char *confFileName, *outFileName;
  confFileName = outFileName = 0;

  for (i = 1; i < argc; i++)
    {
      switch (look_up(argv[i]))
	{
	case 0: // -conf
	  i++;
	  if (i < argc)
	    confFileName = argv[i];
	  break;

	case 1: // --verbose
	case 2: // -v
	  verbose = true;
	  break;

	case 3: // -out
	  outFileDesired = true;
	  i++;
	  if (i < argc)
	    {
	      outFileName = argv[i];

	      if ((fd = open(outFileName, O_RDWR | O_CREAT)) == -1)
		{
		  fprintf(stderr, "out file:  %s", outFileName);
		  perror("main:open:output");
		  exit(EXIT_FAILURE);
		}
	      if (dup2(fd, 1) == -1)
		{
		  perror("main:dup2");
		  close(fd);
		  exit(EXIT_FAILURE);
		}

	      fchmod(fd, S_IRUSR | S_IWUSR);
	    }
	  break;

	default:
	  break;
	}
    }
  // if( (cFN == 0)  || outFileDesired && outFileName == 0
  if ( !confFileName || (outFileDesired && !outFileName))
    {
      fprintf(stderr, "Usage:  %s -conf network.conf\n", argv[0]);
      fprintf(stderr, "\t[-out outputFile] [-v | --verbose]\n");
      fflush(stderr);
    }
  else {
    /* create the controller */
    mfcontroller cnt(verbose, confFileName);

    /* start listening for vertices to be ready,
     *    and wait until the algorithm terminates
     */
    cnt.vertexListen();
  }
}

int look_up(char* s)
{

  int i;
  char* ops[OPS_NUM];

  ops[0] = "-conf";
  ops[1] = "--verbose";
  ops[2] = "-v";
  ops[3] = "-out";

  for (i = 0; i < OPS_NUM; i++)
    {
      if (strcmp(ops[i], s) == 0)
	{
	  return i;
	}
    }
  return -1;
}
