#include <stdlib.h>
#include <iostream.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#include "vertex.h"

#define OPS_NUM 5
int look_up(char* s);

int main(int argc, char** argv)
{
  int id = 0;
  char* confFileName = 0;
  char* outFileName = 0;
  bool outFileDesired = false;
  bool verbose = false;
  int fd, i;

  for (i = 1; i < argc; i++)
    {
      switch (look_up(argv[i]))
	{
	case 0: // -conf
	  i++;
	  if (i < argc)
	    confFileName = argv[i];
	  break;

	case 1: // -id
	  i++;
	  if (i < argc)
	    id = atoi(argv[i]);
	  break;

	case 2: // --verbose
	case 3: // -v
	  verbose = true;
	  break;

	case 4: // -out
	  outFileDesired = true;
	  i++;
	  if (i < argc)
	    {
	      outFileName = argv[i];

              fd = open(outFileName, O_RDWR | O_CREAT);
	      if (fd == -1)
		{
		  fprintf(stderr, "out file:  %s", outFileName);
		  perror("main:open:output");
		  exit(EXIT_FAILURE);
		}
	      if (dup2(fd, 1) == -1)
		{
		  perror("main:dup2");
		  close(fd);
		  exit(EXIT_FAILURE);
		}

	      fchmod(fd, S_IRUSR | S_IWUSR);
	    }
	  break;

	default:
	  break;
	}
    }
  // if( (cFN == 0)  || (id == 0) || outFileDesired && outFileName == 0
  if ( !confFileName || !id       || (outFileDesired && !outFileName))
    {
      cerr << "Usage:  " << argv[0] << " -conf network.conf -id vertexId " << endl
	   << "\t[-out outputFile] [-v | --verbose]" << endl;
    }
  else {
    if (verbose)
      cout << "Just about to create vertex " << id << endl;

    // create the vertex
    vertex myv(id, confFileName, verbose);

    cout << myv;

    if (verbose)
      cout << "finished " << argv[0] << "!!" << endl;

  }
    if (outFileName)
      {
	close(fd);
      }

  return EXIT_SUCCESS;
}

int look_up(char* s)
{

  int i;
  char* ops[OPS_NUM];

  ops[0] = "-conf";
  ops[1] = "-id";
  ops[2] = "--verbose";
  ops[3] = "-v";
  ops[4] = "-out";

  for (i = 0; i < OPS_NUM; i++)
    {
      if (strcmp(ops[i], s) == 0)
	{
	  return i;
	}
    }
  return -1;
}

