#include <GL/glut.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <iostream.h>

static GLfloat spin = 0.0;
static int count=0;
static double start;

static double isnow()
{
	timeval tv;
	gettimeofday(&tv,0);
	return tv.tv_sec+(double)tv.tv_usec/1000000;
}

void display(void)
{
	/* clear all pixels */
	glClear(GL_COLOR_BUFFER_BIT);
	glPushMatrix();
	glRotatef(spin, 0.0, 0.0, 1.0);
	glColor3f(1.0, 1.0, 1.0);
	glRectf(-25.0, -25.0, 25.0, 25.0);
	glPopMatrix();
	glutSwapBuffers();
	double latest;
	if( !((++count)%100))
	{
		latest=isnow();
		cout << count/(latest-start) << endl;
	}
}

void init(void)
{
	/* set clearing (background) color */
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glShadeModel(GL_FLAT);
}

void spinDisplay()
{
	spin=spin+2.0;
	if( spin>360.0)
		spin=spin-360.0;
	glutPostRedisplay();
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-50.0, 50.0, -50.0, 50.0, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void mouse(int button, int state, int x, int y)
{
	switch (button)
	{
	case GLUT_LEFT_BUTTON:
		if(state==GLUT_DOWN)
		{
			count=0;
			start=isnow();
			glutIdleFunc(spinDisplay);
		}
		break;
	case GLUT_MIDDLE_BUTTON:
		if(state==GLUT_DOWN)
			glutIdleFunc(NULL);
		break;
	default:
		break;
	}
}

int main( int argc, char** argv)
{
	glutInit( &argc, argv);
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize( 250, 250);
	glutInitWindowPosition( 100, 100);
	glutCreateWindow(argv[0]);
	init(); // once sent OpenGL commands
	// will be called when the window needs to be displayed
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);
	glutMainLoop();
	return 0;
}

