#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <unistd.h>
#include <iostream.h>
#include <time.h>

static const int points = 6;
static float angle[points] = {0};
static float loc[points][3] = {{0}};
static const float border = 50;
static int color=0;
static int color2=0xfff;
static const int timeout=10000000;

void display(void)
{
	int p=0;
	/* clear all pixels */
	//glClear(GL_COLOR_BUFFER_BIT);
	//glBegin( GL_LINE_LOOP );
	glBegin( GL_LINES );
	color++;
	glColor3f((float)(color&0xf)/16,
		(float)((color&0xf0)>>4)/16,
		(float)((color&0xf00)>>8)/16);
	glVertex3f( loc[p][0], loc[p][1], loc[p][2]);p++;
	glVertex3f( loc[p][0], loc[p][1], loc[p][2]);p++;
	glColor3f(0.0, 0.0, 0.0);
	glVertex3f( loc[p][0], loc[p][1], loc[p][2]);p++;
	glVertex3f( loc[p][0], loc[p][1], loc[p][2]);p++;
	color2--;
	glColor3f((float)(color2&0xf)/16,
		(float)((color2&0xf0)>>4)/16,
		(float)((color2&0xf00)>>8)/16);
	glVertex3f( loc[p][0], loc[p][1], loc[p][2]);p++;
	glVertex3f( loc[p][0], loc[p][1], loc[p][2]);p++;
	glEnd();
	glFlush();
	glutSwapBuffers();
	if( !color2)
		color2=0xfff;
}

void init(void)
{
	/* set clearing (background) color */
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT);
	glShadeModel(GL_FLAT);
	struct timeval tv;
	gettimeofday( &tv, 0);
	srand(tv.tv_usec);
	for(int i=0; i<points;i++)
	{
		angle[i]=(float)(rand()%365)*M_PI/365;
		/* Z is zero for now */
		for(int j=0;j<2;j++)
			loc[i][j]=(rand()%(int)(border/2))-border;
	}
}

void animate()
{
	struct timespec req = { 0, timeout};
	nanosleep(&req, 0);
	for(int i=0; i<points;i++)
	{
#if DEBUG > 3
		if( i )
			cout << "\t\t\t";
		cout << "point " << i << " (" << loc[i][0] << ','
			<< loc[i][1] << ")\n";
#endif /* DEBUG */

		loc[i][0]+=2*cos(angle[i]); // X
		loc[i][1]+=2*sin(angle[i]); // Y
		//loc[i][2]+=sin(angle[i]); // Z
		if(loc[i][0]>border) // X
		{
			loc[i][0]=border;
			// up right
			if( angle[i] < M_PI_2)
				angle[i]=M_PI-angle[i];
			else
			// down right
				angle[i]=3*M_PI-angle[i];
		}
		else
		if(loc[i][0]<-border) // -X
		{
			loc[i][0]=-border;
			// up left
			if( M_PI_2 < angle[i] && angle[i] < M_PI)
				angle[i]=M_PI-angle[i];
			else
			// down left
				angle[i]=3*M_PI-angle[i];
		}
		if(loc[i][1]>border) // Y
		{
			loc[i][1]=border;
			angle[i]=2*M_PI-angle[i];
		}
		else
		if(loc[i][1]<-border) // -Y
		{
			loc[i][1]=-border;
			angle[i]=2*M_PI-angle[i];
		}
	}
	glutPostRedisplay();
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-50.0, 50.0, -50.0, 50.0, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void mouse(int button, int state, int x, int y)
{
	switch (button)
	{
	case GLUT_LEFT_BUTTON:
		if(state==GLUT_DOWN)
			glutIdleFunc(animate);
		break;
	case GLUT_MIDDLE_BUTTON:
		if(state==GLUT_DOWN)
			glutIdleFunc(NULL);
		break;
	case GLUT_RIGHT_BUTTON:
		if(state==GLUT_DOWN)
			glClear(GL_COLOR_BUFFER_BIT);
		break;
	default:
		break;
	}
}

int main( int argc, char** argv)
{
	glutInit( &argc, argv);
	glutInitDisplayMode( GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize( 250, 250);
	glutInitWindowPosition( 100, 100);
	glutCreateWindow(argv[0]);
	init(); // once sent OpenGL commands
	// will be called when the window needs to be displayed
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutIdleFunc(animate);
	glutMouseFunc(mouse);
	glutMainLoop();
	return 0;
}

