#include "parse.h"
#include <stdio.h>
#include <fstream.h>
#include <string.h>

Parse::Parse()
{
	NodeList = new vector<node>;
	LinkList = new vector<link>;
	RemovedList = new vector<link>;
}

Parse::~Parse()
{
	delete NodeList;
	delete LinkList;
	delete RemovedList;
}

vector<node> * Parse::ReturnNodes()
{
	return NodeList;
}

vector<link> * Parse::ReturnLink()
{
	return LinkList;
}

vector<link> * Parse::ReturnRemoved()
{
	return RemovedList;
}

void Parse::ReadFile(char * sFilename)
{
	node NewNode;
	link NewLink;
	char sInput[256];

	strcpy(sInput, "\0");

	ifstream inFile(sFilename);

	//Find the beginning of the data
	while(sInput[0] != 'n')
	{
		inFile.getline(sInput,256,'\n');
	}

	while(sInput[0] != '@')
	{
		//Add a node
		if(sInput[0] == 'n')
		{
			NewNode.m_iX = 0;
			NewNode.m_iY = 0;
			NewNode.m_cType = sInput[strlen(sInput)-1];
			NewNode.m_bOff = false;
			
			bool flag = true;
			int beg = 1;
			int end;
			char temp[10];
			char letter[2];

			strcpy(temp,"\0");

			while(flag)
			{
				if(sInput[beg] != ' ')
				{
					end = beg;
					while(flag)
					{
						if(sInput[end] == ' ')
							flag = false;
						else
						{
							letter[0] =sInput[end];
							letter[1] = '\0';
							strcat(temp,letter);
							end++;
						}
					}
	
					NewNode.m_iNumber = atoi(temp);
				}
				
				else
					beg++;
			}

			NodeList->push_back(NewNode);
		}

		//Add a line
		else
		{
			NewLink.m_bOff = false;
			NewLink.m_iMax = 10000;

			int state = 0;
			int blah = 1;
			bool flag;
			char letter[2];
			char temp[10];
			strcpy(temp,"\0");

			while(state != 3)
			{
				if(sInput[blah] != ' ')
				{
					flag = true;
					while(flag)
					{
						if(sInput[blah] == ' ')
							flag = false;
						else if(sInput[blah] == '\0')
							flag = false;
						else
						{
							letter[0] =sInput[blah];
							letter[1] = '\0';
							strcat(temp,letter);
							blah++;
						}
					}
					
					switch(state)
					{
					case 0:
						NewLink.m_iStart = atoi(temp);
						state++;
						break;
					case 1:
						NewLink.m_iEnd = atoi(temp);
						state++;
						break;
					case 2:
						NewLink.m_iCurrent =atoi(temp);
						state++;
						break;
					}
		
					strcpy(temp,"\0");
				}

				else
					blah++;
			}

			LinkList->push_back(NewLink);
		}
			
		inFile.getline(sInput,256,'\n');
	}

}	

void Parse::PrintNode()
{
	vector<node>::const_iterator p1;
	
	for(p1 = NodeList->begin(); p1 != NodeList->end(); ++p1)
		cout << "Node " << p1->m_iNumber << endl;
}

void Parse::PrintLink()
{
	vector<link>::const_iterator p1;

	for(p1 = LinkList->begin(); p1 != LinkList->end(); ++p1)
		cout << "Link " << p1->m_iStart << "," << p1->m_iEnd << endl;
}

void Parse::PrintRemoved()
{
	vector<link>::const_iterator p1;

	cout << endl;

	for(p1 = RemovedList->begin(); p1 != RemovedList->end(); ++p1)
		cout << "Link " << p1->m_iStart << "," << p1->m_iEnd << endl;
}

void Parse::RemoveUseless()
{
	vector<node>::const_iterator p1;
	vector<link>::const_iterator p2;

	for(p2 = LinkList->begin(); p2 != LinkList->end(); ++p2)
	{
		RemovedList->push_back(*p2);
	}

	for(p1 = NodeList->begin(); p1 != NodeList->end(); ++p1)
	{
		char letter = p1->m_cType;

		if(letter == 's' || letter == 't')
		{
			int nodeNumber = p1->m_iNumber;
			
			for(p2 = RemovedList->begin(); p2 != RemovedList->end(); ++p2)
			{
				if((p2->m_iStart == nodeNumber) || (p2->m_iEnd == nodeNumber))
				{
					RemovedList->erase((link *)p2);
					p2--;
				}
				
			}
		}
	}
}
