#include <vector>

struct node
{
	int m_iX;		//The X location
	int m_iY;		//The Y location
	int m_iNumber;		//The node number
	char m_cType;		//The node type (start/end)
	bool m_bOff;		//true == has been disabled
};

struct link
{
	int m_iStart;		//Starting node
	int m_iEnd;		//Ending node
	int m_iCurrent;		//Current lode
	int m_iMax;		//Max lode
	bool m_bOff;		//true == has been disabled
};

class Parse
{
public:
	Parse();
	~Parse();
	
	vector<node> * ReturnNodes();
	vector<link> * ReturnLink();
	vector<link> * ReturnRemoved();

	void ReadFile(char * sFilename);
	void PrintNode();
	void PrintLink();
	void PrintRemoved();
	void RemoveUseless();
	
private:
	vector<node> * NodeList;
	vector<link> * LinkList;
	vector<link> * RemovedList;
};
	
