#define MINBUTTON_WIDTH 10
#define SPACE_WIDTH 10
#define TOTAL_BORDER_WIDTH 3
#define EDGE_WIDTH 2
#define BUTTONS_NEW 0
#define BUTTONS_RESHAPE 1
#include "button.h"
#include <GL/glut.h>

color_t BB_Background = {0.08f, 0.79f, 0.83f, 0.0f },
       /* Light = {0.50f, 1.0f, 1.0f, 0.0f},
        Dark = {0.02f, 0.54f, 0.54f, 0.0f},*/
        Light = {1.0f, 1.0f, 1.0f, 0.0f},
        Dark = {1.00f, 1.00f, 1.00f, 0.0f},
        Button_BG = {0.22f, 0.78f, 0.77f, 0.0f},
        Button_DR = {0.0f, 0.24f, 0.24f},
        Button_LT = {0.67f, 1.0f, 1.0f, 0.0f};
int BB_Window_ID;
dimen_t Window;
button_t *Buttons;
int Button_Count;
int clicked = -1;

void draw_Buttons();
/* "PRIVATE FUCNTIONS" */
draw_Border(int w, int h, int t, color_t tl, color_t br, color_t bg)
{
   /*paint the background ;-) */
   glClearColor(bg.r, bg.g, bg.b, bg.a);
   glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
   
  /*top-left border*/
   glBegin(GL_QUAD_STRIP);
      glColor3f(tl.r, tl.g, tl.b);
      glVertex2f(0, 0);
      glVertex2f(t, t);
      glVertex2f(0,h);
      glVertex2f(t, h-t);
      glVertex2f(w,h);
      glVertex2f(w-t, h-t);
  glEnd();
       
  /*bottom right corner*/
   glBegin(GL_QUAD_STRIP);
      glColor3f(br.r, br.g, br.b);
      glVertex2f(0,0);
      glVertex2f(t,t);
      glVertex2f(w,0);
      glVertex2f(w-t, t);
      glVertex2f(w,h);
      glVertex2f(w-t, h-t);
   glEnd();
}

int find_widest() {
  int i, returnvalue = -1;

  /*find first button*/
  i=0;
  while ( (i < Button_Count) && (returnvalue < 0)) {
    if (!Buttons[i].is_space) {
      returnvalue = i;
    }
    i++;
  }
  
  if (returnvalue < 0) return returnvalue;
  
  /*find largest*/
  for(i=0; i < Button_Count; i++){
    if(
       (!Buttons[i].is_space) &&
       (Buttons[i].Size.w > Buttons[returnvalue].Size.w)
       ) {
      returnvalue = i;
    }
  }
  return returnvalue;
}

int find_totalwidth()
{
  int i, returnvalue = 0;
  for(i=0; i < Button_Count; i++) {
    if (Buttons[i].is_space)
      returnvalue += SPACE_WIDTH;
    else
      returnvalue += Buttons[i].Size.w;
  }

  return returnvalue;
}
void Recalc_Buttons(int reshape_only)
{
  int i,j,
      length_have = Window.w - 2*TOTAL_BORDER_WIDTH,
      length_need, length_toget;
  pt2d_t Cur_Loc = {TOTAL_BORDER_WIDTH, TOTAL_BORDER_WIDTH};

  for(i=0; i < Button_Count; i++)
    if (!Buttons[i].is_space)
    {
      Buttons[i].Size.h = Window.h- 2*TOTAL_BORDER_WIDTH;
      Buttons[i].Size.w = Buttons[i].Max_Length;
    }

  length_need = find_totalwidth();
  if (length_need > length_have) {
    length_toget = length_need - length_have;
    for(j=0; j < length_toget; j++){
      i = find_widest();
      if (Buttons[i].Size.w > MINBUTTON_WIDTH)
        Buttons[i].Size.w--;
    }
  }

  for(i=0; i < Button_Count; i++){
    if (Buttons[i].is_space){
      Cur_Loc.x += 10;
    } 
    else {
      Buttons[i].Location.x = Cur_Loc.x;
      Buttons[i].Location.y = Cur_Loc.y;
      Cur_Loc.x += Buttons[i].Size.w;
      if(!reshape_only){
        Buttons[i].Window_ID =
             glutCreateSubWindow(BB_Window_ID, Buttons[i].Location.x, 
                                 Buttons[i].Location.y,
                                 Buttons[i].Size.w, Buttons[i].Size.h);
        glutDisplayFunc(ButtonBar_Display);
        glutMouseFunc(ButtonBar_Mouse);
      }
      glutSetWindow(Buttons[i].Window_ID);
      glutPositionWindow(Buttons[i].Location.x, Buttons[i].Location.y);
      glutReshapeWindow(Buttons[i].Size.w, Buttons[i].Size.h);
    }
  }
  
}

void
draw_Buttons(){
   int i;

   for (i=0; i<Button_Count; i++)
   {
     if(!Buttons[i].is_space){
      glutSetWindow(Buttons[i].Window_ID);
      glPushMatrix();
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluOrtho2D(0, Buttons[i].Size.w,
                 0, Buttons[i].Size.h);
      
      if(i==clicked)
        draw_Border(Buttons[i].Size.w, Buttons[i].Size.h,
                    EDGE_WIDTH, Button_DR, Button_LT, Button_BG);
      else
        draw_Border(Buttons[i].Size.w, Buttons[i].Size.h,
                    EDGE_WIDTH, Button_LT, Button_DR, Button_BG);

      if(Buttons[i].DrawFace)
        (*Buttons[i].DrawFace)(EDGE_WIDTH, Buttons[i].Size.h,
                               Buttons[i].Size.w);
      glPopMatrix();
      glutSwapBuffers();
     }
   }
}

int
find_withID(int GL_WindowID)
{
  int i=0, returnvalue=-1;
  
  while((i<Button_Count)){
     if(Buttons[i].Window_ID == GL_WindowID)
       return i;
     i++;
  }
  return -1;
}

void
ButtonBar_Mouse(int button, int state, int x, int y)
{
   int clicked_on;

   if (button == GLUT_LEFT_BUTTON){
      if (state == GLUT_DOWN){
            clicked_on = glutGetWindow();
            clicked_on = find_withID(clicked_on);
            if(clicked_on>=0){
              clicked = clicked_on;
              printf("Click on Index %i\n", clicked);
            }
      }
      else {
         if (clicked >= 0)
         {
           clicked_on = glutGetWindow();
           clicked_on = find_withID(clicked_on);
            if((clicked_on >= 0) && (clicked_on == clicked)){
              if(Buttons[clicked].Action){
               (*Buttons[clicked].Action)();
              }
            }
         }
            clicked = -1;
      }     
   }
}

void
ButtonBar_Reshape(int x, int y, int w, int h)
{
   glutPositionWindow(x,y);
   glutReshapeWindow(w, h);

   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glViewport(0,0,w,h);
   glMatrixMode(GL_MODELVIEW);

   Window.w = w;
   Window.h = h;
   
   Recalc_Buttons(BUTTONS_RESHAPE);
   
}

void 
ButtonBar_Display(void)
{
   glutSetWindow(BB_Window_ID);
   glPushMatrix();
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(0, Window.w, 0, Window.h);
   draw_Border(Window.w, Window.h, EDGE_WIDTH, Light, Dark, BB_Background);
   glPopMatrix();
   glutSwapBuffers();
   draw_Buttons();
}

void Init_ButtonBar(int req_Window_ID,
                    int req_w,
                    int req_h,
                    button_t *req_buttons,
                    int button_count)
{
  Window.w = req_w;
  Window.h = req_h;
  BB_Window_ID = req_Window_ID;
  Button_Count = button_count;
  Buttons = req_buttons;
  clicked = -1;

  glutMouseFunc(ButtonBar_Mouse);

  Recalc_Buttons(BUTTONS_NEW);
}
