#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <GL/glut.h>
#include "triangle.h"
#include "button.h"

int Window_Main, Window_MainDraw, Window_MenuBar, Window_ScrBar1, Window_ScrBar2, Window_Mini;
int width_Main = 500,
    width_Mini = 80;
int height_Main = 500,
    height_MenuBar = 35,
    height_ScrollBars = 10,
    height_Mini = 40;

void Quit(void)
{
  exit(0);
} 
void Quit_Draw(int border, int w, int h)
{
  char string[] = "Quit";
  char *use;

  use=string;
  glPushMatrix();
  glTranslatef(border*2, border*2+5, 0.0f);
  glScalef(0.18f, 0.09f, 1.0f);
  while (*use)  
    glutStrokeCharacter(GLUT_STROKE_ROMAN, *use++);
  glPopMatrix();
}

#define MB_COUNT 2
button_t MenuBar_Buttons[MB_COUNT] = {{0,50,Quit_Draw,Quit},
                                      {0,50,0,0}};
    
void Display_Main()
{
   glutSetWindow(Window_Main);
   glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glutSwapBuffers();
}

void Display_MenuBar()
{
   glutSetWindow(Window_MenuBar);
   ButtonBar_Display();
}

void Display_ScrollBar1()
{
   glutSetWindow(Window_ScrBar1);
   glLoadIdentity();
   glClearColor(0.0f, 1.0f, 0.0f, 0.0f);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glutSwapBuffers();
}
void Display_ScrollBar2()
{
   glutSetWindow(Window_ScrBar2);
   glLoadIdentity();
   glClearColor(0.0f, 0.0f, 1.0f, 0.0f);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glutSwapBuffers();
}
void Display_Mini()
{
   glutSetWindow(Window_Mini);
   glLoadIdentity();
   glClearColor(0.8f, 0.8f, 0.0f, 0.0f);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glutSwapBuffers();
}
void Display_MainDraw()
{
   glutSetWindow(Window_MainDraw);
   MainDraw_Display();  
   Display_Mini();
}     
void Display_All()
{
   Display_MenuBar();
   Display_ScrollBar1();
   Display_ScrollBar2();
   Display_MainDraw();
//   Display_Mini();
}

void change_Size2(int w, int h)
{
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glViewport(0,0,w,h);
   glMatrixMode(GL_MODELVIEW);
}

void change_Size(int w1, int h1)
{
   int tmp_h, tmp_w;
   if(h1 == 0) h1 = 1;

   height_Main = h1;
   width_Main = w1;
   
   glutSetWindow(Window_Main);
   glViewport(0,0,width_Main,height_Main);

   glutSetWindow(Window_MenuBar);
      ButtonBar_Reshape(0, 0, width_Main, height_MenuBar);

   glutSetWindow(Window_ScrBar1);
      glutPositionWindow(0, height_Main - height_ScrollBars);
      tmp_w = width_Main - width_Mini;
      tmp_h = height_ScrollBars;
      glutReshapeWindow(tmp_w, tmp_h);
      change_Size2(tmp_w, tmp_h);

   glutSetWindow(Window_ScrBar2);
      glutPositionWindow(width_Main - height_ScrollBars, height_MenuBar);
      tmp_w = height_ScrollBars;
      tmp_h = height_Main - height_MenuBar - height_Mini;
      glutReshapeWindow(tmp_w, tmp_h);
      change_Size2(tmp_w, tmp_h);

   glutSetWindow(Window_MainDraw);
      MainDraw_Reshape(0, height_MenuBar,
                       width_Main-height_ScrollBars,
                       height_Main - height_MenuBar - height_ScrollBars);

   glutSetWindow(Window_Mini);
      glutPositionWindow(width_Main-width_Mini, height_Main-height_Mini);
      tmp_w = width_Mini;
      tmp_h = height_Mini;
      glutReshapeWindow(tmp_w, tmp_h);
      change_Size2(tmp_w, tmp_h);
   
}

int main(int argc, char **argv)
{
   int temp_h, temp_w;
   
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutInitWindowSize(width_Main, height_Main);
   Window_Main = glutCreateWindow("SubWindow Test");

     glutReshapeFunc(change_Size);
     glutDisplayFunc(Display_Main);
     glutIdleFunc(Display_All);
     
   Window_MenuBar = glutCreateSubWindow(Window_Main, 
                                        0,
                                        0,
                                        width_Main, 
                                        height_MenuBar);
     glutDisplayFunc(ButtonBar_Display);
     Init_ButtonBar(Window_MenuBar, width_Main, height_MenuBar, 
                    MenuBar_Buttons, MB_COUNT);
     
   Window_ScrBar1 = glutCreateSubWindow(Window_Main,
                                        0,
                                        height_Main - height_ScrollBars,
                                        width_Main - width_Mini, 
                                        height_ScrollBars);
     glutDisplayFunc(Display_ScrollBar1);
   Window_ScrBar2 = glutCreateSubWindow(Window_Main,
                                        width_Main - height_ScrollBars,
                                        height_MenuBar,
                                        height_ScrollBars,
                                        height_Main - height_MenuBar - 
                                           height_Mini);
     glutDisplayFunc(Display_ScrollBar2);
     
   temp_h = height_Main - height_MenuBar - height_ScrollBars;
   temp_w = width_Main - height_ScrollBars;
   Window_MainDraw = glutCreateSubWindow(Window_Main,
                                         0,
                                         height_MenuBar,
                                         temp_w, temp_h);
     glutDisplayFunc(Display_MainDraw);

     Init_MainDraw(Window_MainDraw, temp_w, temp_h);
     
   Window_Mini = glutCreateSubWindow(Window_Main,
                                     width_Main - width_Mini,
                                     height_Main - height_Mini,
                                     width_Mini,
                                     height_Mini);
     glutDisplayFunc(Display_Mini);
   
     
   glutMainLoop();
                                     
      
  return 0;                                             
}
