#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <GL/glut.h>
#include "common.h"

#define START_H 500
#define START_W 500
#define MAX_SELECT 100

color_t Background = {0.0f, 0.0f, 0.0f, 0.0f};
dimen_t Window;
pt2d_t  Triangle, Mouse;

int Window_ID,
    tri_is_locked = 1;

float theta = 0.0f;

void
draw_triangle(GLenum mode) {

  /*Load name to identfy the triangle*/
  if (mode == GL_SELECT)
  {
    glLoadName(0); 
  }

  
  /*draw the triangle*/
 
  glBegin(GL_TRIANGLES);
  glColor3f( 1.0f, 0.0f, 0.0f ); glVertex2f( 0.0f*50, 1.0f*50 );
  glColor3f( 0.0f, 1.0f, 0.0f ); glVertex2f( 0.87f*50, -0.5f*50 );
  glColor3f( 0.0f, 0.0f, 1.0f ); glVertex2f( -0.87f*50, -0.5f*50 );
  glEnd();


  /*translate to current position*/

}
int doSelect(GLint x, GLint y)
{
  GLuint selectBuf[MAX_SELECT];
  GLint hits;
  GLint viewport[4];


  glGetIntegerv(GL_VIEWPORT,viewport); /*get viewport geometry*/
  
  /*indentify the buffer for object selection*/
  glSelectBuffer(MAX_SELECT, selectBuf);
  glRenderMode(GL_SELECT);  /*enter select mode*/
  glInitNames();                       /*initalize the name stack*/
  glPushName(~0);
  

  glPushMatrix();
  /*do appropiate rotation*/
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPickMatrix(x, Window.h - y, 2, 2, viewport);
  gluOrtho2D(0, Window.w ,0,  Window.h);
  glMatrixMode(GL_MODELVIEW);
  glTranslatef(Triangle.x, Triangle.y, 0.0f);
  glRotatef(theta, 0.0f, 0.0f, 1.0f);
  glClearColor(Background.r, Background.g, Background.b, Background.a);
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  draw_triangle(GL_RENDER);
  glPopMatrix();
  hits = glRenderMode(GL_RENDER);

  if (hits <= 0) return -1;
  return 0;

}


void 
MainDraw_Mouse(int button, int state, int x, int y) {

  if (button == GLUT_LEFT_BUTTON) {
    if (state == GLUT_DOWN) {
      if(doSelect( (GLint) x, (GLint) y) == 0) {
        Mouse.x = x;
        Mouse.y = y;
        tri_is_locked = 0;
      }
    }
    else {
      if (!tri_is_locked) 
        tri_is_locked = 1;
    }
  }
}

void
MainDraw_Motion(int x, int y) {
 if (!tri_is_locked){
  Triangle.x += x - Mouse.x;
  Triangle.y += Mouse.y - y;
  Mouse.x = x;
  Mouse.y = y;
  glutPostRedisplay();
 }
}

void
MainDraw_Reshape(int x, int y, int w, int h)
{
  glutPositionWindow(x,y);
  glutReshapeWindow(w, h);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glViewport(0,0,w,h);
  glMatrixMode(GL_MODELVIEW);

  Window.w = w;
  Window.h = h;
}


void 
MainDraw_Display(void)
{
  glPushMatrix();
  /*do appropiate rotation*/
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, Window.w, 0, Window.h);
  glMatrixMode(GL_MODELVIEW);
  glTranslatef(Triangle.x, Triangle.y, 0.0f);
  glRotatef(theta, 0.0f, 0.0f, 1.0f);
  glClearColor(Background.r, Background.g, Background.b, Background.a);
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  draw_triangle(GL_RENDER);
  glPopMatrix();
  glutSwapBuffers();
    /*increase theta*/
    theta += 1.0f;
}


/*
void
MainDraw_Menu_Select(int item)
{
  if(item == 0) 
    exit(0);
  glutPostRedisplay();
}
*/
/*That function sets of the main drawing window*/
void Init_MainDraw(int new_Window_ID, int w, int h)
{
  /*set needed internal information*/
  Window_ID = new_Window_ID;
  Window.h = h;
  Window.w = w;
  Triangle.x = h/2;
  Triangle.y = w/2;
      
  /*setup hook functions*/
  glutMouseFunc(MainDraw_Mouse);
  glutMotionFunc(MainDraw_Motion);
/*  glutCreateMenu(MainDraw_Menu_Select);
   glutAddMenuEntry("Quit", 0);
  glutAttachMenu(GLUT_RIGHT_BUTTON);*/
}
