#include "master.h"
#include "container.h"

guiContainer::guiContainer(){
   ControlCount = 0;
   AcceptNulls = false;
}

guiContainer::~guiContainer() {
   ControlList::const_iterator i;

   for(i=controls.begin(); i != controls.end(); i++) {
      delete i->binding;
   }

}

void guiContainer::Pack(guiControl *target) {
  control_info new_control={0,0,0,0,0};

  if (!target) return;

  new_control.binding=target;

  controls.push_back(new_control);
  
  glApplication.Request_SubWindow(this, target);
  
  Repack();
}

void guiContainer::Repack(){
  ControlList::iterator i;

  for(i=controls.begin(); i != controls.end(); i++) {
    i->x = i->binding->get_xHint(Width, Height);
    i->y = i->binding->get_yHint(Width, Height);
    i->w = i->binding->get_wHint(Width, Height);
    i->h = i->binding->get_hHint(Width, Height);
    i->binding->Place(i->x,i->y);
    i->binding->Reshape(i->w,i->h);
  }
  Display();
}
void guiContainer::Display(void) {
  glutSetWindow(Window_ID);
  glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glViewport(0,0,Width,Height);
  glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glClearColor(bg_color.r, bg_color.g, bg_color.b, bg_color.a);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    if (bg_display)
      (*bg_display)();
  glutSwapBuffers();
  controls_Display();
}

void guiContainer::Idle(void) {
  glutSetWindow(Window_ID);
  if (bg_idle)
    (*bg_idle)();
  controls_Idle();
}

void guiContainer::Reshape(int w, int h) {
  if (h<1) h = 1;
  if (w<1) w = 1;
  Height = h;
  Width = w;
  glutSetWindow(Window_ID);
  glutReshapeWindow(Width, Height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glViewport(0,0,Width,Height);
  glMatrixMode(GL_MODELVIEW);
  if (bg_reshape) {
    (*bg_reshape)(w,h);
  }
  controls_Reshape();
}

void guiContainer::Visibility(int state)
{
  glutSetWindow(Window_ID);
  if (bg_visibility)
    (*bg_visibility)(state);
  controls_Visibility(state);
}

void guiContainer::setEnabled(bool value)
{
  Enabled = value;
  controls_Enabled(value);
}

void guiContainer::controls_Display(void) {
  ControlList::const_iterator i;

  for(i=controls.begin(); i != controls.end(); i++) {
    i->binding->Display();
  }
} 

void guiContainer::controls_Idle(void) {
  ControlList::const_iterator i;

  for(i=controls.begin(); i != controls.end(); i++) {
    i->binding->Idle();
  }
} 

void guiContainer::controls_Visibility(int state) {
  ControlList::const_iterator i;

  for(i=controls.begin(); i != controls.end(); i++) {
    i->binding->Visibility(state);
  }
} 

void guiContainer::controls_Enabled(int state) {
  ControlList::const_iterator i;

  for(i=controls.begin(); i != controls.end(); i++) {
    i->binding->setEnabled(state);
  }
} 

void guiContainer::controls_Reshape() {
  ControlList::const_iterator i;

  Repack();

  for(i=controls.begin(); i != controls.end(); i++) {
    i->binding->Reshape(i->w, i->h);
  }
} 

