#ifndef _CONTAINER_H_
#define _CONTAINER_H_

#include "master.h"
#include "control.h"
#include <list>

typedef struct _control_info
{
   guiControl *binding;
   int x;
   int y;
   int w;
   int h;
} control_info;

typedef list<control_info> ControlList;

class guiContainer:public guiControl
{

 public:
    guiContainer();
    virtual ~guiContainer();

    virtual void Display(void);
    virtual void Idle(void);
    virtual void Reshape(int w, int h);
    virtual void Visibility(int state);
    
    virtual void Pack(guiControl *target);
    virtual void Repack();
    virtual void setEnabled(bool value);

 protected:
    
    void controls_Display(void);
    void controls_Idle(void);
    void controls_Visibility(int state);
    void controls_Enabled(int state);
    void controls_Reshape();

    bool AcceptNulls;
    int ControlCount;
    ControlList controls;



};

#endif
