#include "master.h"
#include "control.h"
#include <iostream>

guiControl::guiControl() {
   isInit = 0;
   Parent_ID = -1;
   Window_ID = -1;
   Width = 1;
   Height = 1;
   Cursor = -1;
   State = 0;
   Visible = 0;
   Enabled = 0;
   bg_color.r = 0.0f;
   bg_color.g = 0.0f; 
   bg_color.b = 0.0f;
   bg_display = 0;
   bg_idle = 0;
   bg_mouse = 0;
   bg_motion = 0;
   bg_passivemotion = 0;
   bg_keyboard = 0;
   bg_special = 0;
   bg_visibility = 0;
   bg_reshape = 0;
   bg_entry = 0;
   xHint = 0;
   yHint = 0;
   wHint = 1;
   hHint = 1;
   xHintFunc = yHintFunc = hHintFunc = wHintFunc = 0;
}

guiControl::~guiControl(){
   glApplication.Destroy_Window(Window_ID);
}
void guiControl::setVisible(bool value)
{
  if (Visible != value) {
    Visible = value;
  }
}

void guiControl::setEnabled(bool value)
{
   Enabled = value;
}

void guiControl::Init(int ID, int Parent, int w, int h){
   isInit = 1;
   Window_ID = ID;
   Parent_ID = Parent;
   Width = w;
   Height = h;
   glApplication.SetupWindow(Window_ID);
}

void guiControl::Display() {
  glutSetWindow(Window_ID);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glViewport(0,0,Width,Height);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glClearColor(bg_color.r, bg_color.g, bg_color.b, bg_color.a);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if (bg_display)
    (*bg_display)();
  glutSwapBuffers();
}

void guiControl::Idle() {
  if (bg_idle) {
    glutSetWindow(Window_ID);
    (*bg_idle)();
  }
}

void guiControl::Mouse(int key, int state, int x, int y) {
  if (bg_mouse) {
    glutSetWindow(Window_ID);
    (*bg_mouse)(key,state,x,y);
  }
}

void guiControl::Motion(int x, int y) {
  if (bg_motion) {
    glutSetWindow(Window_ID);
    (*bg_motion)(x,y);
  }
}

void guiControl::PassiveMotion(int x, int y) {
  if (bg_passivemotion) {
    glutSetWindow(Window_ID);
    (*bg_passivemotion)(x,y);
  }
}

void guiControl::Keyboard(unsigned char key, int x, int y) {
  if (bg_keyboard) {
    glutSetWindow(Window_ID);
    (*bg_keyboard)(key,x,y);
  }
}

void guiControl::Special(int key, int x, int y) {
  if (bg_special) {
    glutSetWindow(Window_ID);
    (*bg_special)(key,x,y);
  }
}

void guiControl::Visibility(int state) {
  if (bg_visibility) {
    glutSetWindow(Window_ID);
    (*bg_visibility)(state);
  }
}

void guiControl::Reshape(int w, int h) {
  if (h<1) h = 1;
  if (w<1) w = 1;
  Height = h;
  Width = w;
  glutSetWindow(Window_ID);
  glutReshapeWindow(Width, Height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glViewport(0,0,Width,Height);
  glMatrixMode(GL_MODELVIEW);
  if (bg_reshape) {
    (*bg_reshape)(w,h);
  }
}

void guiControl::Entry(int state) {
  if (bg_entry) {
    glutSetWindow(Window_ID);
    (*bg_entry)(state);
  }
}

void guiControl::Place(int x, int y) {
  glutSetWindow(Window_ID);
  glutPositionWindow(x,y);
}

