#include "common.h"

float shiftx=0.0,shifty=0.0;
float scale=0.0f;

bool fpsLimit=false;

void OnLeftClick(const int b,const int x,const int y)
{
	if(b&B_LEFT)
	fprintf(stderr,"Left click... x=%d,y=%d\n",x,y);
	if(b&B_MIDDLE)
		fprintf(stderr,"              holding Middle button\n");
	if(b&B_RIGHT)
		fprintf(stderr,"              holding Right button\n");
}

void OnRightClick(const int b,const int x,const int y)
{
	fprintf(stderr,"Right click... x=%d,y=%d\n",x,y);
	if(b&B_LEFT)
		fprintf(stderr,"               holding Left button\n");
	if(b&B_MIDDLE)
		fprintf(stderr,"               holding Middle button\n");
}

void OnLeftDrag(const int b,const int dx,const int dy)
{
	int w=glutGet(GLUT_WINDOW_WIDTH),
		h=glutGet(GLUT_WINDOW_HEIGHT);
	float skew,top,bottom,left,right;

	if(w==0) w=1;
	if(h==0) h=1;

	skew=(float)w/h;

	if(w>h)
	{
		shiftx+=2.0f*skew*dx/w/exp(scale);
		shifty+=2.0f*dy/h/exp(scale);
	}
	else
	{
		shiftx+=2.0f*dx/w/exp(scale);
		shifty+=2.0f*skew*dy/h/exp(scale);
	}

// *****
// Constrict displayed borders to x=-1.0..1.0,y=-1.0..1.0
// >> This isn't really correct, doesn't account for window shape
	// Find borders of zoom
	left=-1.0f+1/exp(scale);
	if(shiftx<left) shiftx=left;
	top=skew*left;
	if(shifty<top) shifty=top;
	right=1.0f-1/exp(scale);
	if(shiftx>right) shiftx=right;
	bottom=skew*right;
	if(shifty>bottom) shifty=bottom;
// *****

	if(fpsLimit)
		glutPostRedisplay();
	return;
}

void OnRightDrag(const int b,const int dx,const int dy)
{
	int w=glutGet(GLUT_WINDOW_WIDTH),
		h=glutGet(GLUT_WINDOW_HEIGHT);
	float skew,top,bottom,left,right;
	float zoom=-1.0f*dy/h; // Plus is zoom in, minus is zoom out

	if(w==0) w=1;
	if(h==0) h=1;

	skew=(float)w/h;

	scale+=zoom*5.0f;

// *****
// Constrict displayed borders to x=-1.0..1.0,y=-1.0..1.0
// >> This isn't really correct, doesn't account for window shape
	if(scale<0.0f) scale=0.0f;

	// Find borders of zoom
	left=-1.0f+1/exp(scale);
	if(shiftx<left) shiftx=left;
	top=skew*left;
	if(shifty<top) shifty=top;
	right=1.0f-1/exp(scale);
	if(shiftx>right) shiftx=right;
	bottom=skew*right;
	if(shifty>bottom) shifty=bottom;
// *****

	if(fpsLimit)
		glutPostRedisplay();
}

void OnKeyPress(unsigned char key, int x, int y)
{
	switch(key)
	{
		case 'l':
		case 'L':
			if(fpsLimit)
			{
				// Turn off limiting
				// *Should disable timer, but can't
				glutIdleFunc(idleFunc);
				fpsLimit=false;
			}
			else
			{
				glutTimerFunc(1,timedRedrawFunc,0);
				glutIdleFunc(0);
				fpsLimit=true;
			}
			break;
		
		case 's':
		case 'S':
			glutReshapeWindow(640,480);
			break;

		case 'q':
		case 'Q':
			exit(0);
			break;

		case 'c':
		case 'C':
			shiftx=0;
			shifty=0;
			scale=0;
			break;
	}

	return;
}