#include <GL/glut.h> 
#include <GL/gl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "image.h"
#include "mouse.h"

// ** From setup.cpp
extern float FPS_LastSec,FPS_Avg;
extern char BG_Filename[256];

void doFPSCalc(void);
bool FPSCheck(const float targetFPS);

enum VIEWMODE { VIEW_UNIT, VIEW_PIXEL };
void setView(const VIEWMODE vm);

void changeSize(int w, int h);
void renderBitmapString( float x, float y, void *font, char *string);
// **

// ** From draw.cpp
extern glImage2d *bgimage;
void DrawSetup(void);
void DrawKill(void);
void DrawResize(const int w, const int h);
void renderScene(void);
void idleFunc(void); 
void timedRedrawFunc(int value);
// **

// ** From app.cpp
extern float shiftx,shifty;
extern float scale;
extern bool fpsLimit;

void OnLeftClick(const int b,const int x,const int y);
void OnRightClick(const int b,const int x,const int y);
void OnLeftDrag(const int b,const int dx,const int dy);
void OnRightDrag(const int b,const int dx,const int dy);
void OnKeyPress(unsigned char key, int x, int y);
// **