#include "common.h"

const float PI=3.1415926f;
const float TWOPI=2*PI;

glImage2d *bgimage=0;

float tri(const float x) // triangle wave
{
	float t;

	t=4.0f*fmod(x,PI)/TWOPI;
	if(t<0) t+=4;

	if(t<=1.0f)
		return t;
	else if(t<=3.0f)
		return -(t-2.0f);
	else
		return t-4.0f;
}

void renderScene(void) 
{
	float time=glutGet(GLUT_ELAPSED_TIME)/1000.0f;
	float t,t1;
	const float rate=5.0f;
	char buff[256];
	int i;

	doFPSCalc();

	// Do physics

	// Begin drawing
	//glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT); 
	//glClear(GL_COLOR_BUFFER_BIT); 
	//glClear(GL_DEPTH_BUFFER_BIT); 

	setView(VIEW_PIXEL);
// >> This isn't really correct, doesn't account for window shape
	bgimage->Zoom((1.0-shiftx-1/exp(scale))/2,
		          (1.0-shifty-1/exp(scale))/2,
		          1/exp(scale),1/exp(scale)   );
	bgimage->Draw(0.0f,0.0f);

	setView(VIEW_UNIT);
	glPushMatrix();
	glScalef(exp(scale),exp(scale),1.0f);
	glTranslatef(shiftx,shifty,0.0f);

	// Squares
	for(i=1;i<10;i++)
	{
		glColor3f( ((i%8)&0x1)?1.0:0.0,
				   ((i%8)&0x2)?1.0:0.0,
				   ((i%8)&0x4)?1.0:0.0 );
		glBegin(GL_LINE_LOOP);
			glVertex3f(-i*0.08f,-i*0.08f,0.0f);
			glVertex3f(i*0.08f,-i*0.08f,0.0f);
			glVertex3f(i*0.08f,i*0.08f,0.0f);
			glVertex3f(-i*0.08f,i*0.08f,0.0f);
		glEnd();
	}

	//glColor3f(1.0f,0.0f,0.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	for(t=0.0;t<1.0f;t+=0.02f)
	{
		t1=fmod(time,rate)/rate;
		//t1=0.5f*sin(PI*(t-t1))+0.5f;
		//t1=0.5f*tri(PI*(t-t1))+0.5f;
		glBegin(GL_QUADS);
			glColor4f(0.5f*sin(TWOPI*(10*t-5*t1))+0.5f,0.0f,0.0f,0.75f);
			glVertex3f(1.9f*t-0.95f,0.01f,0.0f);
			glVertex3f(1.9f*t-0.95f,-0.01f,0.0f);
			glColor4f(0.5f*sin(TWOPI*(10*(t+0.02)-5*t1))+0.5f,0.0f,0.0f,0.75f);
			glVertex3f(1.9f*(t+0.02f)-0.95f,-0.01f,0.0f);
			glVertex3f(1.9f*(t+0.02f)-0.95f,0.01f,0.0f);
		glEnd();
	}
	glDisable(GL_BLEND);

	glColor3f(0.0f,1.0f,0.0f);
	t1=fmod(time,rate)/rate;
	glBegin(GL_LINE_STRIP);
		for(t=0.0;t<=1.0f;t+=0.01f)
			glVertex3f(1.9f*t-0.95f,-sin(TWOPI*(t-t1)),0.0f);
	glEnd();
	glPopMatrix();

	setView(VIEW_PIXEL);
	// Display text
	glColor3f(1.0f,1.0f,1.0f);
	sprintf(buff,"FPS: Avg=%4.2f, Last Second=%4.2f",FPS_Avg,FPS_LastSec);
	renderBitmapString(10,20,GLUT_BITMAP_HELVETICA_18,buff);
	renderBitmapString(10,40,GLUT_BITMAP_HELVETICA_18,(char*)glGetString(GL_RENDERER));

	glutSwapBuffers();

	return;
} 

void idleFunc(void) 
{
	//if(!fpsLimit||FPSCheck(10.0))
	glutPostRedisplay();

	return;
}

void timedRedrawFunc(int value)
{
	if(fpsLimit)
	{
		glutTimerFunc(100,timedRedrawFunc,0); // 10 fps
		glutPostRedisplay();
	}
}

void DrawResize(const int w, const int h)
{
	bgimage->Resize(w,h);
}

void DrawSetup(void)
{
	// Register glut functions
	glutDisplayFunc(renderScene); 
	glutIdleFunc(idleFunc);

	bgimage=Create_glImage2d();
	bgimage->Load(BG_Filename);
}

void DrawKill(void)
{
	if(bgimage!=0)
		delete bgimage;
}