// **** Mode support functions ****
#include "image.h"

#include <stdio.h>
#include <string.h>

enum enumMode { NOTSET,SOFTWARE,HARDWARE };
enumMode mode=NOTSET;

void determineMode()
{
	char *r;

	if(mode==NOTSET)
	{
		r=(char*)glGetString(GL_RENDERER);
        if(// M$ Win32 Software OpenGL
           !strcmp(r,"GDI Generic")||
           // SGI Win32 Software OpenGL
		   !strcmp(r,"Generic")||
           // SGI Win32 Software OpenGL w/MMX
		   !strcmp(r,"Generic/MMX")||
           // Mesa3D on Win32 (Software?)
		   !strcmp(r,"Mesa Windows")||
           // Mesa3D on X11 (Software?)
		   !strcmp(r,"Mesa X11")     )
			mode=SOFTWARE;
		else
			mode=HARDWARE;

#ifdef DEBUG
fprintf(stderr,"image.cpp - Detected renderer: %s\n"
		       "                   Chose mode: %s\n",
			   r,(mode==HARDWARE)?"HARDWARE":"SOFTWARE");
#endif

	}
	return;
}

void setHardwareMode()
{
	mode=HARDWARE;
	return;
}

bool isHardwareMode()
{
	determineMode();
	return mode==HARDWARE;
}

void setSoftwareMode()
{
	mode=SOFTWARE;
}

bool isSoftwareMode()
{
	determineMode();
	return mode==SOFTWARE;
}

glImage2d *Create_glImage2d()
{
	determineMode();
	if(mode==HARDWARE)
		return new glImage2dTexture;
	else
		return new glImage2dBitmap;
}
