#include <GL/glut.h>
#include <math.h>
#include <stdlib.h>

#include <stdio.h>

#include "mouse.h"

// Callback storage
void DragNull(const int b,const int dx,const int dy) { };
DRAGFUNC *drag_callbacks[3]={DragNull,DragNull,DragNull};

void ClickNull(const int b,const int x,const int y) { };
CLICKFUNC *click_callbacks[3]={ClickNull,ClickNull,ClickNull};

// GLUT Callbacks
void MouseButtons(int button, int state, int x, int y);
void MouseMotion(int x, int y);

int lastx,lasty;
const int clickzone=2;

int pressed;
int possibleclick;

void Mouse_Init()
{
	glutMouseFunc(MouseButtons);
    glutMotionFunc(MouseMotion);

	return;
}

DRAGFUNC *SetDragCallback(const int b,DRAGFUNC *callback)
{
	DRAGFUNC *retval;

	if(callback==0)
		callback=DragNull;

	if(b&B_RIGHT)
	{
		retval=drag_callbacks[2];
		drag_callbacks[2]=callback;
	}
	if(b&B_MIDDLE)
	{
		retval=drag_callbacks[1];
		drag_callbacks[1]=callback;
	}
	if(b&B_LEFT)
	{
		retval=drag_callbacks[0];
		drag_callbacks[0]=callback;
	}

	return retval;
}

CLICKFUNC *SetClickCallback(const int b,CLICKFUNC *callback)
{
	CLICKFUNC *retval;

	if(callback==0)
		callback=ClickNull;

	if(b&B_RIGHT)
	{
		retval=click_callbacks[2];
		click_callbacks[2]=callback;
	}
	if(b&B_MIDDLE)
	{
		retval=click_callbacks[1];
		click_callbacks[1]=callback;
	}
	if(b&B_LEFT)
	{
		retval=click_callbacks[0];
		click_callbacks[0]=callback;
	}

	return retval;
}

void MouseButtons(int button, int state, int x, int y)
{
	int oldpressed=pressed,changed;

	if(state==GLUT_DOWN)
	{
		switch(button)
		{
			case GLUT_LEFT_BUTTON:
				pressed|=B_LEFT;
				possibleclick|=B_LEFT;
				break;
			case GLUT_MIDDLE_BUTTON:
				pressed|=B_MIDDLE;
				possibleclick|=B_MIDDLE;
				break;
			case GLUT_RIGHT_BUTTON:
				pressed|=B_RIGHT;
				possibleclick|=B_RIGHT;
				break;
			//default:
		}
	}
	else // GLUT_UP
	{
		if((button==GLUT_LEFT_BUTTON)&&
		   (pressed&possibleclick&B_LEFT))
		{
			click_callbacks[0](pressed,lastx,lasty);
		}
		else if((button==GLUT_MIDDLE_BUTTON)&&
		        (pressed&possibleclick&B_MIDDLE))
		{
			click_callbacks[1](pressed,lastx,lasty);
		}
		else if((button==GLUT_RIGHT_BUTTON)&&
		        (pressed&possibleclick&B_RIGHT))
		{
			click_callbacks[2](pressed,lastx,lasty);
		}

		// Update state
		switch(button)
		{
			case GLUT_LEFT_BUTTON:
				pressed&=!B_LEFT;
				possibleclick&=!B_LEFT;
				break;
			case GLUT_MIDDLE_BUTTON:
				pressed&=!B_MIDDLE;
				possibleclick&=!B_MIDDLE;
				break;
			case GLUT_RIGHT_BUTTON:
				pressed&=!B_RIGHT;
				possibleclick&=!B_RIGHT;
				break;
			//default:
		}
	}
	lastx=x;
	lasty=y;
}

void MouseMotion(int x, int y)
{
	// Check to see if we've left
	//  the clickzone
	if((abs(x-lastx)>clickzone)||
	   (abs(y-lasty)>clickzone)  )
		// We have, so this isn't a click
		possibleclick=B_NONE;

	if(possibleclick==B_NONE)
	{
		if(pressed==B_LEFT)
			drag_callbacks[0](pressed,x-lastx,y-lasty);
		if(pressed==B_MIDDLE)
			drag_callbacks[1](pressed,x-lastx,y-lasty);
		if(pressed==B_RIGHT)
			drag_callbacks[2](pressed,x-lastx,y-lasty);
		lastx=x;
		lasty=y;
	}
}

