#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <GL/glut.h>

/*define starting parameters*/
#define START_H 500
#define START_W 500
#define MAX_SELECT 100


/*start triangle in the middle with it's position locked*/
float theta = 0.0f;
int tri_x = START_W / 2, 
    tri_y = START_H / 2,
    winh  = START_H, 
    winw  = START_W,
    mouse_x, 
    mouse_y,
    tri_is_locked = 1;

/*trianlge drawinh*/
void
draw_triangle(GLenum mode) {

  /*
  **If we are in select mode we must assign a name to 
  **the triangle
  **/
  if (mode == GL_SELECT)
  {
    glLoadName(0); 
  }

  
  /*
  **draw the triangle
  **in some modes the vertex order matters
  **/
 
  glBegin(GL_TRIANGLES);
  glColor3f( 1.0f, 0.0f, 0.0f ); glVertex2f( 0.0f*50, 1.0f*50 );
  glColor3f( 0.0f, 1.0f, 0.0f ); glVertex2f( 0.87f*50, -0.5f*50 );
  glColor3f( 0.0f, 0.0f, 1.0f ); glVertex2f( -0.87f*50, -0.5f*50 );
  glEnd();



}

/*
** identfy what is seleted
**/
int doSelect(GLint x, GLint y)
{
  GLuint selectBuf[MAX_SELECT];
  GLint hits;
  GLint viewport[4];


  /*
  **need some idea of what to address the selecting to
  **/
  glGetIntegerv(GL_VIEWPORT,viewport);
  
  /*
  **The Select mode reqired that we provide the stack 
  **to store Selected Name Data
  **/
  glSelectBuffer(MAX_SELECT, selectBuf);
  glRenderMode(GL_SELECT);      /*enter select mode*/
  glInitNames();                /*initalize the name stack*/
  glPushName(~0);
  

  /*
  **Note this looks like like the display function here
  **/
  glPushMatrix();
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
 
  /*
  **This is an addition between LoadIdentity and Ortho2D
  **/
  gluPickMatrix(x, winh - y, 2, 2, viewport);
  
  gluOrtho2D(0,winw,0, winh);
  glMatrixMode(GL_MODELVIEW);
  glTranslatef(tri_x,tri_y,0.0f);
  glRotatef(theta, 0.0f, 0.0f, 1.0f);
  glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  draw_triangle(GL_SELECT);
  glPopMatrix();
  
  /*
  **By Return to Render Modem a index with no of  hits will
  **be returned
  */
  hits = glRenderMode(GL_RENDER);

  /*
  **Only on think to hit so I will only check to see
  **if a number <=0 is returned
  */
  if (hits <= 0) return -1;
  return 0;

}

/*
**Function to handle mouse actions
*/
void mouse_function(int button, int state, int x, int y) {

  /*
  ** If a left click
  */
  if (button == GLUT_LEFT_BUTTON) {
    /*
    ** Down 
    */
    if (state == GLUT_DOWN) {
      /*
      ** And the Select function return 0
      */
      if(doSelect( (GLint) x, (GLint) y) == 0) {
        /* 
        ** Record the first mouse position
        ** so and can get movment delta,
        ** then unlock the triangle position
        */
        mouse_x = x;
        mouse_y = y;
        tri_is_locked = 0;
      }
    }
    else {
      /*
      ** If the Left Mouse Button is released
      ** any any case make sure the triangle 
      ** position is locked
      **/
      if (!tri_is_locked) 
        tri_is_locked = 1;
    }
  }
}

/*
** This funciton handles dragging
**/
void motion_function(int x, int y) {

  /*
  ** If I have an unlocked triangle, 
  ** apply delta to the triangle coords(remember verticle
  ** goes backwards.  And the get the current mouse position
  ** and redisplay
  **/
 if (!tri_is_locked){
  tri_x += x - mouse_x;
  tri_y += mouse_y - y;
  mouse_x = x;
  mouse_y = y;
  glutPostRedisplay();
 }
}

/*
** Make sure the coord are const according to window size
**/
void
reshape_function(int w, int h)
{
  glViewport(0,0,w,h);
  winw = w;
  winh = h;
}

/*simply draw hook function*/
void 
display_function(void)
{
  
  glPushMatrix();
  /*do appropiate rotation*/
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0,winw,0, winh);
  glMatrixMode(GL_MODELVIEW);
  glTranslatef(tri_x,tri_y,0.0f);
  glRotatef(theta, 0.0f, 0.0f, 1.0f);
  glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  draw_triangle(GL_RENDER);
  glPopMatrix();
  glutSwapBuffers();
    /*increase theta*/
    theta += 1.0f;
}

/*VERY simply menu selection*/
void
menu_select(int item)
{
  if(item == 0) 
    exit(0);
  glutPostRedisplay();
}


int main(int argc, char **argv)
{
  /*Initalize Glut with any special args*/
  glutInit(&argc, argv);
  /*set the window attributes*/
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(500,500);
  glutCreateWindow("Spinning Triangle Test");

  /*setup the hooks*/
  glutMouseFunc(mouse_function);
  glutMotionFunc(motion_function);
  glutReshapeFunc(reshape_function);
  glutDisplayFunc(display_function);
  glutIdleFunc(display_function);

  /*setup the menu*/
  glutCreateMenu(menu_select);
  glutAddMenuEntry("Quit", 0);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

  /*the main loop function*/
  glutMainLoop();
  return 0;
}
