
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 
#include<stdlib.h>
#include <strings.h>

void error(char *msg)
{
    perror(msg);
    exit(0);
}

int main(int argc, char *argv[])
{
    int sockfd, portno, n;
    struct sockaddr_in serv_addr;
    struct hostent *server;
    long size, sizel, size_in, size_inl;
    long* psize = new long;
    long* psize_inl = new long;
    char *buffer;
    char*  buff_in;
    if (argc < 3) {
       fprintf(stderr,"usage %s hostname port\n", argv[0]);
       exit(0);
    }
    portno = atoi(argv[2]);
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0) 
        error("ERROR opening socket");
    server = gethostbyname(argv[1]);
    if (server == NULL) {
        fprintf(stderr,"ERROR, no such host\n");
        exit(0);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy((char *)server->h_addr, 
         (char *)&serv_addr.sin_addr.s_addr,
         server->h_length);
    serv_addr.sin_port = htons(portno);
    if (connect(sockfd,(struct sockaddr *)&serv_addr,sizeof(serv_addr)) < 0) 
        error("ERROR connecting");
    //tell the server how many bytes to expect
    *psize = htonl(size);
    n = write(sockfd,psize,sizeof(size));
    if (n < 0) 
         error("ERROR writing to socket");
    //send the data to the server
    n = write(sockfd,buffer,size);
    
    //how big is the size of the file coming back? get that from the server
    n = read(sockfd,psize_inl,sizeof(size_in));
    if (n < 0) 
         error("ERROR reading from socket");
    size_inl = (*psize_inl);
    size_in = ntohl(size_inl);

    n = read(sockfd,buff_in,size_in);
    if (n < 0)
         error("ERROR reading from socket");
    //delete some pointers
    delete psize;
    delete psize_inl;
    return 0;
}

