
       //********************************************************
       //                                                       *
       //                                                       *
       //  Class:      CS397 Winter 2001                        *
       //                                                       *
       //  Programmer: Don Benne                                *
       //  File name:  server.cpp                               *
       //                                                       *
       //********************************************************
/* A simple server in the internet domain port number
   is passed as an argument from the command line. You cannot mix client 
   and server on different size architectures. For example if server runs 
   on 32 bit architectures then the client must also be 32 bit */
 
#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>

#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>

#include <netinet/in.h>
#include <strings.h>
#include <unistd.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <signal.h>
#include <string.h>


void SigCatcher(int n);

int main(int argc, char *argv[])
{
     int n, sockfd, newsockfd, portno, pid;
     #ifdef _SOCKLEN_T
     socklen_t clilen;
     signal(SIGCHLD,SigCatcher); //no wait for child on Solaris
     #else
     int clilen;
     signal(SIGCLD,SIG_IGN); //don't wait for children on HP-UX
     #endif
     struct sockaddr_in serv_addr, cli_addr;
     
     //signal(SIGCHLD,SigCatcher);

     if (argc < 2) 
     {
         //didn't provide a port number...oops
         cerr << "ERROR, no port provided\n";
         exit(1);
     }

     n = system( "type GOLD");
     if(n > 0)
     {
        cerr<<"Server startup aborted"<<endl;
        cerr<<"Plese put GOLD in the path"<<endl;
        exit(0);
      }

     sockfd = socket(AF_INET, SOCK_STREAM, 0);
     if (sockfd < 0)
     {
        cerr<<"ERROR, opening socket\n";
        exit(0);
      }
        
     bzero((char *) &serv_addr, sizeof(serv_addr)); //zero out the array
     
     portno = atoi(argv[1]);//get the port number from the command line
     
     serv_addr.sin_family = AF_INET; //set internet type of socket
     
     serv_addr.sin_addr.s_addr = INADDR_ANY;
     serv_addr.sin_port = htons(portno);
     
     if (bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0)
     {
         cerr<< "ERROR on binding\n";
         exit(1);
      }
      
     listen(sockfd,5);
     
     clilen = sizeof(cli_addr);
     
     while (1) //while loop waits for connections and then forks
     {
         newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
         if (newsockfd < 0) 
             cerr<< "ERROR on accept\n";
             
         pid = fork();
         if (pid < 0)
         {
             cerr<< "ERROR on fork\n";
          }
             
         if (pid == 0)
         {
             cout <<"I forked"<<endl;
             int n;    
             FILE *inp;
             FILE *outp;  
             long fsize; 
             char* powdat; /* ptr to buffer */
             //long pgetsize = new long;
             long insize;
             
	     int pid;
	     pid = getpid();
             char command[255]="GOLD -in ";    
             char spid[255];
             char powerout[20];
             sprintf(spid, "%d", pid); 
	     
	     
             close(sockfd); //close this because we don't need it
             n = read(newsockfd, (void*)&insize, sizeof(insize));
             if(n<0)
             {
                cerr<<"error reading from socket"<<endl;
		close(newsockfd);
		exit(0);
              }
             //insize = *pgetsize;
             insize = ntohl(insize);
	     
             //allocate space to get file from client
             char* buffer = new char[insize+1];
      
             bzero(buffer,insize);
             long result = 0;
             long received = 0;
             while(received != insize)
             {
                  received += result;
                  result = read(newsockfd,buffer+received,insize-received);
                  if (result < 0) 
                  {
                     cerr<< "ERROR reading from socket: reading data from client\n";
		     close(newsockfd);
		     exit(0);
                  }
                     
             }
             
             received += result;
             //buffer[received] = 0;
              

              //write the file to the disk for processing
              outp = fopen(spid, "wb");
	      if(outp == NULL)
	      {
	         cerr << "Couldn't open file for writing"<<endl;
		 close(newsockfd);
		 exit(0);
	      }
		 
              fwrite(buffer, 1, insize, outp);
	      fclose(outp);
              
               
               //make the system call to execute power program
               //but it needs to have the random filename added
               strcat(command, spid);
               strcat(command, " -out ");
               strcpy(powerout, spid);
               strcat(powerout, ".out");
               strcat(command, powerout);
               strcat(command, " -rep s -quiet");
	       cout << command << endl;
               n = system(command);
	       if(n<0)
	       {
	          cerr << "couldn't execute system command"<<endl;
		  close(newsockfd);
		  exit(0);
	       }

               

              inp = fopen( powerout, "rb" );
	      if(inp == NULL)
	      {
	         cerr << "Couldn't open file for reading"<<endl;
		 close(newsockfd);
		 exit(0);
	      }
              
              fseek( inp, 0l, SEEK_END );
              fsize = ftell( inp );


              /* allocate buffer for whole file */
              if( (powdat = (char*)malloc( fsize )) == NULL )
              {
                  cerr<<"couldn't allocate space for file"<<endl;
                  exit( 0 );
               } 


              /* back to byte 0, read whole thing */
               fseek( inp, 0l, SEEK_SET );
               fread( powdat, 1, fsize, inp );
               fclose( inp );
               long* psendsize = new long;
               fsize = htonl(fsize);
               *psendsize = fsize;
             n = write(newsockfd, psendsize, sizeof(fsize));
             n = write(newsockfd, powdat, fsize);
             free(powdat);             
   
             if (n < 0) 
             {
                cerr<< "ERROR writing to socket\n";
              }
	      
	    
	      
	      n = unlink(spid);
	      if (n < 0) 
              {
                cerr<< "Unable to cleanup input file";
              }
	      
	      n = unlink(powerout);
	      if (n < 0)
	      {
	        cerr<< "Unable to cleanup output file";
              }
	      
	     close(newsockfd);
             exit(0);
         }
         else close(newsockfd);
     } /* end of while */
     return 0; /* we never get here */
}

void SigCatcher(int n)
{
    wait3(NULL,WNOHANG,NULL);    
}


