//
// string2.h  Keith David Winkler December 20, 1998
//
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>

#ifndef STRING2_H
#define STRING2_H

#include <iostream.h>

class String {
		friend ostream &operator << (ostream &, const String &);
		friend istream &operator >> (istream &, String &);

	public:

		String(void);			// Default                     constructor
		String(const char *  );	 	// conversion (char to string) constructor
		String(const String &);	        // copy-initialization         constructor
		String(int);			// conversion (int to string)  constructor

		~String();			// Destructor

		const String &operator=(const String &);
		String & operator = (const char *);
  		String & operator = (char);
		String & operator += (const String &);
		String & operator += (char);    
		String operator+(const String &) const;

		int operator !  () const;
		int operator == (const String &) const;
		int operator != (const String &) const;
		int operator <  (const String &) const;
		int operator >  (const String &) const;
		int operator >= (const String &) const;
		int operator <= (const String &) const;
		int operator /  (const String &) const;
		int operator /  (const char[]) const;
		int operator /  (const char &) const;
		char &operator[] (int) const;
		String operator() (int, int);


		////////////////////////////
		//
		// const member functions
		//
		////////////////////////////

		inline const char* String::chars() const { return &(sPtr[0]); }  
		void System()        const;             
		int getlen() const { return length; };  
		int Instr(char []) const;


		String Left(char A)  const;	        


		// Return all characters to the right of the first char A
		//

		String Right(char A) const;             


		// Returns 1 if so, 0 otherwise.
		//

		int IsNumeric()      const;		


		// Convert to integer.
		//
		
		int Integer() const { return atoi(sPtr);  };  

		
		////////////////////////////
		//
		// modifying member functions
		//
		////////////////////////////


		// Read line from istream and store in sPtr
		//
		
		istream & getline(istream &, int);     
 		void Replace(char [], char );

		// Erases the string.
		//
		void Clear();                           


	private:
		char *sPtr;
		int length;

};

#endif /* STRING2_H */


