// problem on (near) line 137 for % replacement, $23x becomes #x3 (no "")
#include "www.form.h"

/////////////////////////////////////
//
// Default Constructor
//
/////////////////////////////////////
Entry::Entry() 
{
	Num_Entries=0;
}

/////////////////////////////////////
//
// Load() - Loads values passed from
//          form out of the enviormental
//          variable QUERY_STRING and 
//          strores them as private data
//          members of this class.
//
//	use GetXY(...) to get coords from imagemap
//
/////////////////////////////////////
void Entry::Load(char* match = 0) 
{
	int i;
	char HexChar[3]; HexChar[2] = 0;
	char* CharPtr;
	String In;

	String Method = getenv("REQUEST_METHOD");

        if (Method=="GET")
	{
		In = getenv("QUERY_STRING");
	}
	else if (Method=="POST")
        {  // form is not METHOD GET  // hopefully method = post
		if (getenv("CONTENT_LENGTH") == 0)
		{
			cout << "no CONTENT_LENGTH var! <BR>" << endl;
			return;
		}
		i = atoi(getenv("CONTENT_LENGTH"));
		CharPtr = new char[i+1];

        	scanf("%s", CharPtr);
		In = CharPtr;

        	while(i -= strlen(CharPtr)>0)
        	{
			scanf("%s",CharPtr);
			In += CharPtr;
        	}
	        delete[]CharPtr;
	}

	if (DEBUG) 
	{
		cout << "---------------------------------------------<br>" << endl;
		cout << In << "<br>" << endl;
	}
        Num_Entries = LoadVars(In, Name, Val);
	String CookieString = getenv("HTTP_COOKIE");
        if (DEBUG)
	   cout << "------<br>" << CookieString << "<br>-----" << endl;
        if ((CookieString != "") && (match))
	{
		String tmpCookieString = CookieString;
		int i, j = CookieString.Instr(match) + strlen(match);
		if (CookieString[j] == '\'') j++;
		for (i=j; i<CookieString.getlen(); i++)
		{
			tmpCookieString[i-j] = CookieString[i];
		}
		tmpCookieString[i-j] = 0;
		tmpCookieString = tmpCookieString.Left('\'');
		tmpCookieString = tmpCookieString.Left(';');
		Num_Cookies = LoadVars(tmpCookieString, CName, CVal);
	}
	else Num_Cookies = 0;	
}

int Entry::LoadVars(String InList, String Label[], String Value[])
{
	int NumEntries = 0, i;
	char HexChar[3]; HexChar[2] = 0;
	char ToReplace[5];
	char* CharPtr;

   	while(InList.getlen() > 2) 
	{	
		if (DEBUG) 
		{
			cout << "---------------------------------------------<br>" << endl;
		}
		Label[NumEntries] = InList.Left('=');
		InList = InList.Right('=');
		Value[NumEntries]  = InList.Left('&').Left('?');
		InList = InList.Right('&');
	
		if (DEBUG)
		{
			cout << Label[NumEntries] << "<br>" << endl;
			cout << "BEFORE + REPLACE: " << Value[NumEntries] << "<br>" << endl;
		}
		
		for(i=0;i<Value[NumEntries].getlen();i++)
		{
			if (Value[NumEntries][i] == '+') Value[NumEntries][i] = ' ';
		}
		if (DEBUG)
		{
			cout << "AFTER  + REPLACE:" << Value[NumEntries] << "<br>" << endl;
		}

		// Convert hex numbers to proper characters.
		while( strstr(Value[NumEntries].chars(),"%"))
		{
			strcpy(ToReplace,"%");
			if (DEBUG) 
			{
				cout << "Value[NumEntries] : " << Value[NumEntries] << "<br>" << endl;
			}
			CharPtr = strstr(Value[NumEntries].chars(),"%");
			CharPtr++;
			HexChar[0] = *CharPtr; CharPtr++;
			HexChar[1] = *CharPtr;
			if (DEBUG)
			{
				cout << "HexChar[0]: " << HexChar[0] << "<br>" << endl;
				cout << "HexChar[1]: " << HexChar[1] << "<br>" << endl;
				cout << "HexChar   : " << HexChar    << "<br>" << endl;
				cout << HexCharsToChar(HexChar) 
			             << "<br><br>" << endl;
			}
			strcat(ToReplace, HexChar);
			Value[NumEntries].Replace(ToReplace,HexCharsToChar(HexChar) );
		}

		if (DEBUG)
		{
			cout << "AFTER HEX CONVERT: " << Value[NumEntries] << "<br>" << endl;
		}
		NumEntries++;
	}
	Value[NumEntries] = ""; // terminate list
        return(NumEntries);
}

/////////////////////////////////////
//
// DebugPrint() - Prints everything that
//                the form passed.  Mainly
//                used for debugging.
//
/////////////////////////////////////
void Entry::DebugPrint() const
{
	int i;
	String In = String(getenv("QUERY_STRING"));
	cout << "<hr><br>" << endl;	
	cout << "In is:  " << In << endl;
	cout << "<hr><br>" << endl;
	cout << "Number of variables from form is:" << Num_Entries << "<br><br>" << endl;	
	for(i=0;i<Num_Entries;i++) { cout << Name[i] << " = " << Val[i] << "<br>" << endl; }
	cout << "Number of Cookies from browser is:" << Num_Cookies << "<br><br>" << endl;	
	for(i=0;i<Num_Cookies;i++) { cout << CName[i] << " = " << CVal[i] << "<br>" << endl; }
}


/////////////////////////////////////
//
// GetEntry
//
/////////////////////////////////////

String Entry::GetEntry(String Query) const 
{
	int i;
	for(i=0;i<=Num_Entries;i++) { if (Name[i]==Query) break; }
	return (Val[i]);
}

String Entry::GetCookie(String Query) const 
{
	int i;
	for(i=0;i<=Num_Cookies;i++) { if (CName[i]==Query) break; }
	return (CVal[i]);
}

String Entry::GetName(int i) const 
{
	if (i>Num_Entries) return("");
	return (Name[i]);
}

String Entry::GetValue(int i) const 
{
	if (i>Num_Entries) return("");
	return (Val[i]);
}

void Entry::GetXY(int &x, int &y) const
{  // assume parameters specify imagemap coords link.bin?x,y
	char *coords = getenv("QUERY_STRING");
	String In = coords;
//        cout << "++" << coords << "++" << endl;
	coords += In.Instr("?") + 1;
//        cout << "++" << coords << "++" << endl;

	sscanf(coords, "%d,%d",&x,&y);
	return;
}

/*
String Entry::List() const
{  // return list of params "?booga1=asdf&booga2=as34" (but not "?234,534")
	char *coords = getenv("QUERY_STRING");
	String In = coords;
	In[In.Instr("?")] = 0;
	return(In);
}
*/
////////////////////////////////
//
// This currently works ONLY
//  with two digit hex numbers
//
////////////////////////////////

char HexCharsToChar(const char A[]) 
{
	int Base,j;
	float Sum=0;

	if (DEBUG)
	{
		cout << "Arguement to HexCharsToChar is: " << A << "<br>" << endl;
	}

	for(j=0;j<=1;j++) 
	{
		if (int(A[j]) < 58) Base = int(A[j]) - 48;
		if (int(A[j]) >= 58) Base = int(A[j]) - 55;

		if (DEBUG) 
		{
			cout << "BASE: " << Base << "<br>" << endl;
		}
	
		Sum += Base * pow(16,(j==1 ? 0 : 1) );
	}
	
	return char( int(Sum)  );
}
