#include "bar.h"
#include <list>

using namespace std;

guiBar::guiBar(){
   AcceptNulls = true;
   SpaceWidth = 10;
   MinWidth = 20;
   BorderWidth = 2;
}

int guiBar::FindWidest(ControlList::iterator &x) {
   ControlList::iterator returnval, i;

   /*empty return error*/
   if (controls.empty()) return 0;
  
   /*If anything the first one would be widest*/
   returnval = controls.begin();

   /*loop through everything in list*/
   for(i=controls.begin(); i !=controls.end(); i++) {
     /*if it is a control and name it widest*/
      if (i->binding && (i->w > returnval->w)) 
         returnval = i;
   }

   x = returnval;
   return 1;
}

int guiBar::FindTotalWidth() {
   int total = 0;
   ControlList::iterator i;

   /*add up all the widths of in the control list*/
   for(i=controls.begin(); i != controls.end(); i++) {
      total += i->w;
   }

   return total;
}

void guiBar::Repack() {
   ControlList::iterator i;
   int j,w,h,curx, cury, width_need, width_toget;

   /*set starting[xy] and [wh]*/
   cury = curx = BorderWidth;
   w = Width - 2*BorderWidth;
   h = Height - 2*BorderWidth;
   
   /*fill out w/h with the hint values*/
   for(i=controls.begin(); i != controls.end(); i++) {
      if (i->binding) {
         i->w = i->binding->get_wHint(Width, Height);
         if (i->w < MinWidth) {
           i->w = MinWidth;
         }
         i->h = h;
      }
      else {
         i->w = SpaceWidth;
         i->h = h;
      }
   }

   /*calculated needed width*/
   width_need = FindTotalWidth();

   /*if it's too much */
   if(w < width_need) {
      /*find the difference it too many pixels*/
      width_toget = width_need - w;
      /*
      ** even distribute by finding widest each time
      ** and subtract only one pixel
      */
      for(j=0; j < width_toget; j++) {
         if(!FindWidest(i)) 
            return;
         
         if(i->w > MinWidth) {
           i->w--;
         }
      }
   }

   /* calculate x,y and then tell each child how it is to draw */
   for(i=controls.begin(); i != controls.end(); i++) {
      i->x = curx;
      i->y = cury;
      curx += i->w;
      if (i->binding)
      {
         i->binding->Place(i->x,i->y);
         i->binding->Reshape(i->w,i->h);
      }
   }
   
}
