#include "button.h"

guiButton::guiButton() {
   BorderWidth = 3;
   Dark.r = 0.5f;
   Dark.g = 0.5f;
   Dark.b = 0.5f;
   Dark.a = 0.0f;
   Light.r = 1.0f;
   Light.g = 1.0f;
   Light.b = 1.0f;
   Light.a = 0.0f;
   State = 0;
   action = 0;
   face = 0;
}

void guiButton::DrawBorder(int reversed) {
   color_t tl,br;
   float t;

   Push();    
   
   if (reversed) {
      tl = Dark;
      br = Light;
   }
   else {
      tl = Light;
      br = Dark;
   }
   t = (BorderWidth * 2)/3;
   glPushMatrix(); 

   /*top-left border*/
   glBegin(GL_QUAD_STRIP);
   glColor3f(tl.r, tl.g, tl.b);
   glVertex2f(0, 0);
   glVertex2f(t, t);
   glVertex2f(0,Height);
   glVertex2f(t, Height-t);
   glVertex2f(Width, Height);
   glVertex2f(Width-t, Height-t);
   glEnd();
   
   /*bottom right corner*/
   glBegin(GL_QUAD_STRIP);
   glColor3f(br.r, br.g, br.b);
   glVertex2f(0,0);
   glVertex2f(t,t);
   glVertex2f(Width,0);
   glVertex2f(Width-t, t);
   glVertex2f(Width, Height);
   glVertex2f(Width-t, Height-t);
   glEnd();
   glPopMatrix(); 
   
   Pop();
}

void guiButton::Display(void) {
if(glApplication.isStarted()) {
   Push();
   
   /*backgroud*/
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glViewport(0,0,Width,Height);
   gluOrtho2D(0,Width,0,Height);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glClearColor(bg_color.r, bg_color.g, bg_color.b, bg_color.a);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   /*custom background*/
   if (bg_display)
      (*bg_display)();

   /*face*/
   if (face)
      (*face)(Width,Height,BorderWidth);

   /*border*/
   DrawBorder(State);

   glutSwapBuffers();
   
   Pop();
}
}

void guiButton::Mouse(int button, int state, int x, int y) {
  Push(); 
  if (button == GLUT_LEFT_BUTTON){
      if (state == GLUT_DOWN){
         State = 1;
      }
      else {
         /*
         ** in order to action the pointer must be in the
         ** dimensions of the window
         */
         if ((State) && 
             (x>=0) && (x<=Width) &&
             (y>=0) && (y<=Height) &&
             (action))
         {
               (*action)();
         }
         State = 0;
      }
   }
   else {
      State = 0;
   }
   /*need this to make animation*/

#ifdef WIN32
   Display();
#else
   Touch();
#endif

   Pop();
} 
