#include "status.h"


guiStatusBar::guiStatusBar()
{
	BorderWidth =3;
	Dark.r = 0.5f;
   Dark.g = 0.5f;
   Dark.b = 0.5f;
   Dark.a = 0.0f;
   Light.r = 1.0f;
   Light.g = 1.0f;
   Light.b = 1.0f;
   Light.a = 0.0f;
	Text_Color.r = 0.0f;
	Text_Color.g = 0.0f;
	Text_Color.b = 0.0f;
	Text_Color.a = 0.0f;
	Text_Length = 0;
	Text = 0;
}

guiStatusBar::~guiStatusBar() 
{
	delete[] Text;
}

void guiStatusBar::setString(int length, char *string)
{
	if(Window_ID >= 0) {
	Push();
   }
	
	if((length <= 0)||(!string))
	{
		delete[] Text;
		Text_Length = 0;
	}
	else
	{
		delete[] Text;
		Text = new char[length+1];
		strncpy(Text, string, length);
		Text[length] = 0;
		Text_Length = length;
	}
	
	if(Window_ID >= 0) {
  	  glutPostRedisplay();
	  Pop();
   }
}

void guiStatusBar::DrawBorder(float eff_Height, float eff_Width, 
                         		float startx, float starty, int reversed)
{
   color_t tl,br;
	float t;
	
	if (reversed) {
      tl = Dark;
      br = Light;
   }
   else {
      tl = Light;
      br = Dark;
   }
	
	Push();
	t = BorderWidth / 3.00f;
	glPushMatrix();
	
	/*topleft border*/
	glBegin(GL_QUAD_STRIP);
   glColor3f(tl.r, tl.g, tl.b);
   glVertex2f(startx            , starty);
   glVertex2f(startx+t          , starty+t);
   glVertex2f(startx            , starty+eff_Height);
   glVertex2f(startx+t          , starty+eff_Height-t);
   glVertex2f(startx+eff_Width  , starty+eff_Height);
   glVertex2f(startx+eff_Width-t, starty+eff_Height-t);
   glEnd();
	
	/*bottom right corner*/
   glBegin(GL_QUAD_STRIP);
   glColor3f(br.r, br.g, br.b);
   glVertex2f(startx            , starty);
   glVertex2f(startx+t          , starty+t);
   glVertex2f(startx+eff_Width  , starty);
   glVertex2f(startx+eff_Width-t, starty+t);
   glVertex2f(startx+eff_Width  , starty+eff_Height);
   glVertex2f(startx+eff_Width-t, starty+eff_Height-t);
   glEnd();
   
	glPopMatrix(); 
	
	Pop();
}

void guiStatusBar::DrawText() {
	float scaler,
			translationx,
			translationy;
			//adjustment=1.0;
   int i;
	
	scaler = (Height-2*BorderWidth-2)/175.0f;
	translationx = BorderWidth+2;
	translationy = BorderWidth+2+31*scaler;
	//scaler = (Height-2*BorderWidth-2)*adjustment;
	if (Text)
	{
		Push();
		glPushMatrix();
		glColor3f(Text_Color.r, Text_Color.g, Text_Color.b);
		glTranslatef(translationx, translationy, 0);
		glScalef(scaler, scaler, 1.0f);
		for (i=0; i<Text_Length; i++) {
			glutStrokeCharacter(GLUT_STROKE_ROMAN, Text[i]);
		}
		glPopMatrix();
		Pop();
	}
}

void guiStatusBar::Display(void) 
{
if (glApplication.isStarted()){
	float t;
	Push();
		
	  /*backgroud*/
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glViewport(0,0,Width,Height);
   gluOrtho2D(0,Width,0,Height);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glClearColor(bg_color.r, bg_color.g, bg_color.b, bg_color.a);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   /*custom background*/
   if (bg_display)
      (*bg_display)();

 	DrawText();
	if (BorderWidth)
	{
		t = BorderWidth / 3;
  	   DrawBorder(Height,Width,0,0,false);
	   DrawBorder(Height-4*t, Width-4*t, 2*t, 2*t, true);
	}
	
	glutSwapBuffers();
	
	Pop();
}
}
