/********************************************************************
** bar.h
**------------------------------------------------------------------
** ButtonBar control
*******************************************************************/
#ifndef _BAR_H_
#define _BAR_H_



#include "master.h"
#include "window.h"


class guiBar:public guiContainer
{
 public:
    /******************************************************
    ** guiBar::guiBar()
    **----------------------------------------------------
    ** post: In suppercedance to super classes
    **       -Pack will accept NULL (they are spaces)
    **       -Space Width = 10
    **       -Min Control Width = 20
    **       -Borderwidth = 2
    *****************************************************/
    guiBar();

    /*
    ** Set various variable (non Push/Pop)
    */
    void setSpaceWidth(int value);
    void setMinWidth(int value);
    void setBorderWidth(int value);

    /*
    ** Overload this is to inline packing
    */
    virtual void Repack();

 private:
    int SpaceWidth;
    int MinWidth;
    int BorderWidth;

    /*
    ** Basic functions to allow easy repacking
    ** FindWidest finds the widest control left to 
    **    right so it can be shrunk
    **    return 0 on fail, non0 on success
    ** FindToalWidth finds the total pixels the
    **    bar would life to have to display
    */
    int FindWidest(ControlList::iterator &x);
    int FindTotalWidth();
};

inline void guiBar::setBorderWidth(int value) {
  if (value >= 0)
    BorderWidth = value;
  else
    BorderWidth = 0;
};

inline void guiBar::setSpaceWidth(int value) {
  if (value >= 0) 
    SpaceWidth = value;
  else
    SpaceWidth = 0;
};

inline void guiBar::setMinWidth(int value) {
  if (value > 0)
    MinWidth = value;
  else
    MinWidth = 1;
};

#endif
