/********************************************************************
** button.h
********************************************************************/
#ifndef _BUTTON_H_
#define _BUTTON_H_

#include "master.h"
#include "control.h"

class guiButton:public guiControl {
 public:
    /***********************************************************
    ** guiButton::guiButton()
    **----------------------------------------------------------
    ** Superceding truths over the constructors for super class
    **    -borderwidth = 3
    **    -Dark color is gray, light color is white
    **    -no set action or face display
    ***********************************************************/
    guiButton();

    /*overidden function WITH Push()/Pop()*/
    virtual void Display();
    virtual void Mouse(int key, int state, int x, int y);

    /*set the raising highlights*/
    color_t getdk_Color();
    color_t gethl_Color();
    
    /*
    ** set all the button specific stuff
    */
    void setAction(void (*func)(void));
    void setFace(void (*func)(int,int,int));
    void setBorderWidth(int value);
    void setdk_Color(color_t value);
    void sethl_Color(color_t value);
           
 private:
    /*
    ** Though we set the border, the raiser portion is only 
    ** a function of this
    */
    void DrawBorder(int reversed);
    void (*action)(void);
    void (*face)(int,int,int);
    int BorderWidth;
    color_t Dark;
    color_t Light;
    
};

inline color_t guiButton::getdk_Color() {
   return Dark;
};

inline color_t guiButton::gethl_Color() {
   return Light;
};

inline void guiButton::setdk_Color(color_t value) {
   Dark = value;
};

inline void guiButton::sethl_Color(color_t value) {
   Light = value;
};

inline void guiButton::setAction(void (*func)(void)) {
   action = func;
};

inline void guiButton::setFace(void (*func)(int,int,int)) {
   face = func;
};

inline void guiButton::setBorderWidth(int value) {
   if (value >= 0){
      BorderWidth = value;
   }
   else{
      BorderWidth = 0;
   }
};

#endif
