#ifndef _PHILXPM_H_
#define _PHILXPM_H_
#include <map>
#include <master.h>

using namespace std;

/*******************************************************
** This is a very simple parse of certain XPM format
** images.  The assumptions are:
**
**      * the Characters per pixel = 1
**      * the colors are given in #RRGGBB or NONE format
**      * the XPM data will not be freed until the class
**        is no longer needed (yeah this was a hack)
*******************************************************/
typedef map<char, color_t, less< char > > colormap;

class philxpm {
 public:
   philxpm();   /*general con/decon don't do much*/
   ~philxpm();

   int parse(char *data[]); /*this is where it begins*/
   void clear(); /*to clear the associated XPM*/
      
   color_t get_color(int pixel); /*need a color?*/
   int get_height();
   int get_width();
   char get_pixel(int x, int y); /*get pixel value*/
  private:
   int width;
   int height;
   colormap colortable;
   char **pix_data;
   
};


inline color_t philxpm::get_color(int pixel)
{
   color_t returnvalue={0.0f,0.0f,0.0f,0.0f};

   if (colortable.find(pixel) != colortable.end())
    returnvalue = colortable[pixel];

   return returnvalue;
};

inline int philxpm::get_height() {
   return height;
};

inline int philxpm::get_width() {
   return width;
};

inline char philxpm::get_pixel(int x, int y) {
   char returnvalue = 0;

   if ((x>=0) && (y>=0) && (x<width) && (y < height))
      returnvalue = pix_data[height-1-y][x];

   return returnvalue;
};

inline void philxpm::clear() {
   pix_data = 0;
   height = 0;
   width = 0;
};

   

#endif

