#include <philxpm.h>
#include <stdio.h>
#include <stdlib.h>

philxpm::philxpm()
{
  width = height = 0;
  pix_data = 0;
}

philxpm::~philxpm()
{
  clear();
}

int philxpm::parse(char *data[])
{
  int cpp,      /*character per pixel*/
      i,        /*counter*/
      ret,      /*return value for sscang*/
      ncolors;  /*number of colors in icon*/
      
  char color;           /*the pixel character*/
  char color_value[7];  /*the read in value for a pixel*/
  color_t tobe_stored;  /*color_values convered to float rgba*/
  unsigned int r,g,b;   /*used to pull out the hex information*/
 
  clear();
  
  /*read in image information*/
  ret = sscanf(data[0], "%i %i %i %i", &width, &height, &ncolors, &cpp);
  /*must read all values*/
  if (ret != 4) return 1;
  /*don't support cpp != 1*/
  if (cpp != 1) return 2;
  
  /*for each color line*/
  for(i=0; i<ncolors; i++)
  {
     /*scan the colortable line*/
     ret = sscanf(data[1+i], "%c\tc %7c", &color, color_value);
     /*must read all values*/
     if (ret != 2) return 3;

     /*assume being with N translates to a NONE/none for transparency*/
     if (color_value[0]=='N' || color_value[0]=='n') {
        tobe_stored.r=0.0f;
        tobe_stored.g=0.0f;
        tobe_stored.b=0.0f;
        tobe_stored.a=0.0f;
     }
     else
     {
       color_value[7] = 0;
        /*otherwise scan in the assumed hex value*/
        ret = sscanf(color_value, "#%2x%2x%2x", &r,&g,&b);
        /*must read all values*/
        if (ret != 3) return 4;
        /*will get on 255 scale convert to non-transparent float*/
        tobe_stored.r = (float)r/255.0;
        tobe_stored.g = (float)g/255.0;
        tobe_stored.b = (float)b/255.0;
        tobe_stored.a = 1.00;
     }
     /*make a character mapping*/
     colortable[color] = tobe_stored;
  }

  
  /*save point where the pixels begin*/
  pix_data = &data[1+ncolors];
  
  return 0; 
}
   
